﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class RitmoControle : MonoBehaviour
{
	public static RitmoControle Instance
	{
		get
		{
			if (m_instance == null)
			{
				m_instance = GameObject.FindObjectOfType<RitmoControle>();
				DontDestroyOnLoad(m_instance.gameObject);
			}

			return m_instance;
		}
	}

	public float intervalo = 0.5f;
	public float tolerancia = 0.1f;
	public float tempoCompasso = 4f;
	public AudioSource somBase;
	public AudioSource somPadraoA;
	public AudioSource somPadraoB;
	public Text contador;
	public bool primeiraVez;
	public bool habilitado;

	static RitmoControle m_instance;
	float temporizador;
	bool apertouSomPadraoA = false;
	bool apertouSomPadraoB = false;

	void Start ()
	{
		somBase.Play();
		somPadraoA.Play();
		somPadraoB.Play();

		Reiniciar();
	}

	public void Reiniciar()
	{
		habilitado = true;
		primeiraVez = true;
		somPadraoA.volume = 0;
		somPadraoB.volume = 0;
		temporizador = 0;
	}

	public void GameOver()
	{
		somPadraoA.volume = 0;
		somPadraoB.volume = 0;
		temporizador = 0;
		habilitado = false;
	}

	void Update ()
	{
		if ( !habilitado )
			return;
		
		if ( !primeiraVez )
		{
			temporizador += Time.deltaTime;
		}

		if ( Input.anyKeyDown )
		{
			if ( primeiraVez && ( Input.GetKeyDown( KeyCode.Z ) || Input.GetKeyDown( KeyCode.M ) ))
			{
				primeiraVez = false;
				Personagem.Instance.telaInicio.SetActive( false );
				SpawnerController.Instance.Reiniciar();
			}

			if ( temporizador > tempoCompasso - tolerancia )
			{
				if ( Input.GetKeyDown( KeyCode.Z ) )
				{
					apertouSomPadraoA = true;
				}
				else if ( Input.GetKeyDown( KeyCode.M ) )
				{
					apertouSomPadraoB = true;
				}
			}

			if ( temporizador < 0f + tolerancia )
			{
				if ( Input.GetKeyDown( KeyCode.Z ) )
				{
					Personagem.Instance.mudarTrajetoria( 0 );

					somPadraoA.volume = 1;
				}
				else if ( Input.GetKeyDown( KeyCode.M ) )
				{
					Personagem.Instance.mudarTrajetoria( 1 );

					somPadraoB.volume = 1;
				}
			}
		}

		// Se não apertou nada...
		if ( temporizador > tolerancia && somPadraoA.volume == 0 && somPadraoB.volume == 0 )
		{
			Personagem.Instance.mudarTrajetoria( 2 );			
		}

		if ( temporizador > tempoCompasso )
		{
			temporizador = 0;
			somPadraoA.volume = 0;
			somPadraoB.volume = 0;

			if ( apertouSomPadraoA )
			{
				Personagem.Instance.mudarTrajetoria( 0 );
				somPadraoA.volume = 1;
			}

			if ( apertouSomPadraoB )
			{
				Personagem.Instance.mudarTrajetoria( 1 );
				somPadraoB.volume = 1;
			}

			apertouSomPadraoA = false;
			apertouSomPadraoB = false;
		}
			
		contador.text = "" + (int) temporizador;	
	}
}
